<template>
	<div class="follow" ref="follow" :style="style">
		<slot />
	</div>
</template>

<script>
export default {
	props: {
		align: {
			type: String,
			default: "top",
			validator(value) {
				return ["top", "center", "bottom"].indexOf(value) !== 0;
			}
		},

		justify: {
			type: String,
			default: "left",
			validator(value) {
				return ["left", "center", "right"].indexOf(value) !== 0;
			}
		},

		enabled: {
			type: Boolean,
			default: true
		}
	},

	data() {
		return {
			isMounted: false,
			observer: null,
			pos: { x: 0, y: 0 },
			dragEventCallback: null
		};
	},

	computed: {
		style() {
			if (!this.isMounted) {
				return;
			}

			return {
				left: this.pos.x - this.offset.x + "px",
				top: this.pos.y - this.offset.y + "px",
				position: "absolute"
			};
		},

		offset() {
			return {
				x: this.offsetX(),
				y: this.offsetY()
			};
		}
	},

	watch: {
		enabled(newValue) {
			this.enabled = newValue;

			if (this.enabled) {
				this.startFollowing();
			} else {
				this.stopFollowing();
			}
		}
	},

	mounted() {
		this.isMounted = true;

		// create slot observer
		this.observer = new MutationObserver(
			function() {
				this.offset.x = this.offsetX();
				this.offset.y = this.offsetY();
			}.bind(this)
		);

		// setup slot observer
		this.observer.observe(this.$el, {
			attributes: true,
			childList: true,
			characterData: true,
			subtree: true
		});

		if (this.enabled) {
			this.startFollowing();
		}
	},

	beforeDestroy() {
		// clean up observer
		this.observer.disconnect();

		if (this.enabled) {
			this.stopFollowing();
		}
	},

	methods: {
		follow(e) {
			this.pos.x = e.offsetX;
			this.pos.y = e.offsetY;
		},

		startFollowing() {
			this.dragEventCallback = this.follow.bind(this);
			this.$refs.follow.parentElement.addEventListener(
				"pointermove",
				this.dragEventCallback
			);
		},

		stopFollowing() {
			this.$refs.follow.parentElement.removeEventListener(
				"pointermove",
				this.dragEventCallback
			);
			this.dragEventCallback = null;
		},

		offsetY() {
			let y;
			switch (this.align) {
				case "center":
					y = this.$refs.follow.clientHeight / 2;
					break;
				case "bottom":
					y = this.$refs.follow.clientHeight;
					break;
				default:
					y = 0;
			}
			return y;
		},

		offsetX() {
			let x;
			switch (this.justify) {
				case "center":
					x = this.$refs.follow.clientWidth / 2;
					break;
				case "right":
					x = this.$refs.follow.clientWidth;
					break;
				default:
					x = 0;
			}
			return x;
		}
	}
};
</script>

<style lang="scss" scoped>
.follow {
	pointer-events: none;
}
</style>
